<html>
<head>
  <title>PL Profiler Report for current</title>

  <script language="javascript">
    // ----
    // toggle_div()
    //
    //  JS function to toggle one of the functions to show/block.
    // ----
    function toggle_div(hs_id, div_id) {
        var h_elem = document.getElementById(hs_id);
        var d_elem = document.getElementById(div_id);
        if (d_elem.style.display == "block") {
            d_elem.style.display = "none";
            h_elem.innerHTML = "show";
        } else {
            d_elem.style.display = "block";
            h_elem.innerHTML = "hide";
        }
    }

    // ----
    // set_stat_bars()
    // ----
    function set_stat_bars() {
        // Loop over all tables that are of linestats class.
        var tbls = document.getElementsByClassName("linestats");
        for (var i = 0; i < tbls.length; i++) {
            tbl = tbls[i];
            rws = tbl.rows;

            // Get the function level totals of the counters from the
            // second row (the pseudo line-0 row).
            vals = rws[1].getElementsByTagName("td");
            var exec_max = parseFloat(vals[1].innerHTML)
            var total_max = parseFloat(vals[2].innerHTML)
            var longest_max = parseFloat(vals[3].innerHTML)

            // Guard against division by zero errors.
            if (exec_max == 0) exec_max = 1;
            if (total_max == 0) total_max = 1;
            if (longest_max == 0) longest_max = 1;

            // Now we can calculate and set the bars relative to those
            // function level totals.
            for (var j = 1; j < rws.length; j++) {
                var vals = rws[j].getElementsByTagName("td");

                var val = parseFloat(vals[1].innerHTML)
                // var pct = val / exec_max * 100;
                // vals[1].style.backgroundSize = pct + "% 100%";
                // vals[1].style.backgroundSize = "0% 100%";
                vals[1].innerHTML = "<code>" + val.toLocaleString() + "</code>";

                val = parseFloat(vals[2].innerHTML)
                pct = val / total_max * 100;
                pct_str = "(" + pct.toFixed(2) + "%)"
                var need_spc = 10 - pct_str.length;
                for (var k = 0; k < need_spc; k++) {
                    pct_str = "&nbsp;" + pct_str;
                }
                vals[2].style.backgroundSize = pct + "% 100%";
                vals[2].innerHTML = "<code>" + val.toLocaleString() + "&nbsp;&micro;s" + pct_str + "</code>";

                val = parseFloat(vals[3].innerHTML)
                // pct = val / longest_max * 100;
                // vals[3].style.backgroundSize = pct + "% 100%";
                vals[3].innerHTML = "<code>" + val.toLocaleString() + "&nbsp;&micro;s" + "</code>";
            }
        }
    }
  </script>


  <style>
    h1,h2,h3,h4	{ color:#2222AA;
                }

    h1		{ font-family: Helvetica,Arial;
                  font-weight: 700;
                  font-size: 24pt;
                }

    h2		{ font-family: Helvetica,Arial;
                  font-weight: 700;
                  font-size: 18pt;
                }

    h3,h4	{ font-family: Helvetica,Arial;
                  font-weight: 700;
                  font-size: 16pt;
                }

    p,li,dt,dd	{ font-family: Helvetica,Arial;
                  font-size: 14pt;
                }

    pre		{ font-family: Courier,Fixed;
                  font-size: 14pt;
                }

    samp	{ font-family: Courier,Fixed;
                  font-weight: 900;
                  font-size: 14pt;
                }

    big		{ font-weight: 900;
                  font-size: 120%;
                }

    .bar        { background-color: white;
                  background-image: url(data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAgAAAAICAIAAABLbSncAAAACXBIWXMAAAsTAAALEwEAmpwYAAAAB3RJTUUH4AYEDho2r7uRnQAAAB1pVFh0Q29tbWVudAAAAAAAQ3JlYXRlZCB3aXRoIEdJTVBkLmUHAAAAFUlEQVQI12P8dlOcARtgYsABBqcEAH/aAfYx26o/AAAAAElFTkSuQmCC);
                  background-repeat: no-repeat;
                }
  </style>

</head>
<body bgcolor="#ffffff" onload="set_stat_bars()">
<h1>PL Profiler Report for current</h1>
<p>
<!-- description here -->
</p>
<h2>PL/pgSQL Call Graph</h2>
<center>
b'<?xml version="1.0" standalone="no"?>\n<!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN" "http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd">\n<svg version="1.1" width="1200" height="98" onload="init(evt)" viewBox="0 0 1200 98" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink">\n<defs >\n\t<linearGradient id="background" y1="0" y2="1" x1="0" x2="0" >\n\t\t<stop stop-color="#eeeeee" offset="5%" />\n\t\t<stop stop-color="#eeeeb0" offset="95%" />\n\t</linearGradient>\n</defs>\n<style type="text/css">\n\t.func_g:hover { stroke:black; stroke-width:0.5; cursor:pointer; }\n</style>\n<script type="text/ecmascript">\n<![CDATA[\n\tvar details, svg;\n\tfunction init(evt) { \n\t\tdetails = document.getElementById("details").firstChild; \n\t\tsvg = document.getElementsByTagName("svg")[0];\n\t}\n\tfunction s(info) { details.nodeValue = "Function: " + info; }\n\tfunction c() { details.nodeValue = \' \'; }\n\tfunction find_child(parent, name, attr) {\n\t\tvar children = parent.childNodes;\n\t\tfor (var i=0; i<children.length;i++) {\n\t\t\tif (children[i].tagName == name)\n\t\t\t\treturn (attr != undefined) ? children[i].attributes[attr].value : children[i];\n\t\t}\n\t\treturn;\n\t}\n\tfunction orig_save(e, attr, val) {\n\t\tif (e.attributes["_orig_"+attr] != undefined) return;\n\t\tif (e.attributes[attr] == undefined) return;\n\t\tif (val == undefined) val = e.attributes[attr].value;\n\t\te.setAttribute("_orig_"+attr, val);\n\t}\n\tfunction orig_load(e, attr) {\n\t\tif (e.attributes["_orig_"+attr] == undefined) return;\n\t\te.attributes[attr].value = e.attributes["_orig_"+attr].value;\n\t\te.removeAttribute("_orig_"+attr);\n\t}\n\tfunction update_text(e) {\n\t\tvar r = find_child(e, "rect");\n\t\tvar t = find_child(e, "text");\n\t\tvar w = parseFloat(r.attributes["width"].value) -3;\n\t\tvar txt = find_child(e, "title").textContent.replace(/\\([^(]*\\)/,"");\n\t\tt.attributes["x"].value = parseFloat(r.attributes["x"].value) +3;\n\t\t\n\t\t// Smaller than this size won\'t fit anything\n\t\tif (w < 2*12*0.59) {\n\t\t\tt.textContent = "";\n\t\t\treturn;\n\t\t}\n\t\t\n\t\tt.textContent = txt;\n\t\t// Fit in full text width\n\t\tif (/^ *$/.test(txt) || t.getSubStringLength(0, txt.length) < w)\n\t\t\treturn;\n\t\t\n\t\tfor (var x=txt.length-2; x>0; x--) {\n\t\t\tif (t.getSubStringLength(0, x+2) <= w) { \n\t\t\t\tt.textContent = txt.substring(0,x) + "..";\n\t\t\t\treturn;\n\t\t\t}\n\t\t}\n\t\tt.textContent = "";\n\t}\n\tfunction zoom_reset(e) {\n\t\tif (e.attributes != undefined) {\n\t\t\torig_load(e, "x");\n\t\t\torig_load(e, "width");\n\t\t}\n\t\tif (e.childNodes == undefined) return;\n\t\tfor(var i=0, c=e.childNodes; i<c.length; i++) {\n\t\t\tzoom_reset(c[i]);\n\t\t}\n\t}\n\tfunction zoom_child(e, x, ratio) {\n\t\tif (e.attributes != undefined) {\n\t\t\tif (e.attributes["x"] != undefined) {\n\t\t\t\torig_save(e, "x");\n\t\t\t\te.attributes["x"].value = (parseFloat(e.attributes["x"].value) - x - 10) * ratio + 10;\n\t\t\t\tif(e.tagName == "text") e.attributes["x"].value = find_child(e.parentNode, "rect", "x") + 3;\n\t\t\t}\n\t\t\tif (e.attributes["width"] != undefined) {\n\t\t\t\torig_save(e, "width");\n\t\t\t\te.attributes["width"].value = parseFloat(e.attributes["width"].value) * ratio;\n\t\t\t}\n\t\t}\n\t\t\n\t\tif (e.childNodes == undefined) return;\n\t\tfor(var i=0, c=e.childNodes; i<c.length; i++) {\n\t\t\tzoom_child(c[i], x-10, ratio);\n\t\t}\n\t}\n\tfunction zoom_parent(e) {\n\t\tif (e.attributes) {\n\t\t\tif (e.attributes["x"] != undefined) {\n\t\t\t\torig_save(e, "x");\n\t\t\t\te.attributes["x"].value = 10;\n\t\t\t}\n\t\t\tif (e.attributes["width"] != undefined) {\n\t\t\t\torig_save(e, "width");\n\t\t\t\te.attributes["width"].value = parseInt(svg.width.baseVal.value) - (10*2);\n\t\t\t}\n\t\t}\n\t\tif (e.childNodes == undefined) return;\n\t\tfor(var i=0, c=e.childNodes; i<c.length; i++) {\n\t\t\tzoom_parent(c[i]);\n\t\t}\n\t}\n\tfunction zoom(node) { \n\t\tvar attr = find_child(node, "rect").attributes;\n\t\tvar width = parseFloat(attr["width"].value);\n\t\tvar xmin = parseFloat(attr["x"].value);\n\t\tvar xmax = parseFloat(xmin + width);\n\t\tvar ymin = parseFloat(attr["y"].value);\n\t\tvar ratio = (svg.width.baseVal.value - 2*10) / width;\n\t\t\n\t\t// XXX: Workaround for JavaScript float issues (fix me)\n\t\tvar fudge = 0.0001;\n\t\t\n\t\tvar unzoombtn = document.getElementById("unzoom");\n\t\tunzoombtn.style["opacity"] = "1.0";\n\t\t\n\t\tvar el = document.getElementsByTagName("g");\n\t\tfor(var i=0;i<el.length;i++){\n\t\t\tvar e = el[i];\n\t\t\tvar a = find_child(e, "rect").attributes;\n\t\t\tvar ex = parseFloat(a["x"].value);\n\t\t\tvar ew = parseFloat(a["width"].value);\n\t\t\t// Is it an ancestor\n\t\t\tif (0 == 0) {\n\t\t\t\tvar upstack = parseFloat(a["y"].value) > ymin;\n\t\t\t} else {\n\t\t\t\tvar upstack = parseFloat(a["y"].value) < ymin;\n\t\t\t}\n\t\t\tif (upstack) {\n\t\t\t\t// Direct ancestor\n\t\t\t\tif (ex <= xmin && (ex+ew+fudge) >= xmax) {\n\t\t\t\t\te.style["opacity"] = "0.5";\n\t\t\t\t\tzoom_parent(e);\n\t\t\t\t\te.onclick = function(e){unzoom(); zoom(this);};\n\t\t\t\t\tupdate_text(e);\n\t\t\t\t}\n\t\t\t\t// not in current path\n\t\t\t\telse\n\t\t\t\t\te.style["display"] = "none";\n\t\t\t}\n\t\t\t// Children maybe\n\t\t\telse {\n\t\t\t\t// no common path\n\t\t\t\tif (ex < xmin || ex + fudge >= xmax) {\n\t\t\t\t\te.style["display"] = "none";\n\t\t\t\t}\n\t\t\t\telse {\n\t\t\t\t\tzoom_child(e, xmin, ratio);\n\t\t\t\t\te.onclick = function(e){zoom(this);};\n\t\t\t\t\tupdate_text(e);\n\t\t\t\t}\n\t\t\t}\n\t\t}\n\t}\n\tfunction unzoom() {\n\t\tvar unzoombtn = document.getElementById("unzoom");\n\t\tunzoombtn.style["opacity"] = "0.0";\n\t\t\n\t\tvar el = document.getElementsByTagName("g");\n\t\tfor(i=0;i<el.length;i++) {\n\t\t\tel[i].style["display"] = "block";\n\t\t\tel[i].style["opacity"] = "1";\n\t\t\tzoom_reset(el[i]);\n\t\t\tupdate_text(el[i]);\n\t\t}\n\t}\t\n]]>\n</script>\n<rect x="0.0" y="0" width="1200.0" height="98.0" fill="url(#background)"  />\n<text text-anchor="middle" x="600.00" y="24" font-size="17" font-family="Verdana" fill="rgb(0,0,0)"  >PL Profiler Report for current</text>\n<text text-anchor="" x="10.00" y="81" font-size="12" font-family="Verdana" fill="rgb(0,0,0)" id="details" > </text>\n<text text-anchor="" x="10.00" y="24" font-size="12" font-family="Verdana" fill="rgb(0,0,0)" id="unzoom" onclick="unzoom()" style="opacity:0.0;cursor:pointer" >Reset Zoom</text>\n<g class="func_g" onmouseover="s(\'all (7,037 samples, 100%)\')" onmouseout="c()" onclick="zoom(this)">\n<title>all (7,037 samples, 100%)</title><rect x="10.0" y="49" width="1180.0" height="15.0" fill="rgb(221,207,50)" rx="2" ry="2" />\n<text text-anchor="" x="13.00" y="59.5" font-size="12" font-family="Verdana" fill="rgb(0,0,0)"  ></text>\n</g>\n<g class="func_g" onmouseover="s(\'plp.inventory_in_stock() oid=17627 (7,037 samples, 100.00%)\')" onmouseout="c()" onclick="zoom(this)">\n<title>plp.inventory_in_stock() oid=17627 (7,037 samples, 100.00%)</title><rect x="10.0" y="33" width="1180.0" height="15.0" fill="rgb(219,197,2)" rx="2" ry="2" />\n<text text-anchor="" x="13.00" y="43.5" font-size="12" font-family="Verdana" fill="rgb(0,0,0)"  >plp.inventory_in_stock() oid=17627</text>\n</g>\n</svg>\n'
</center>
<h2>List of functions detailed below</h2>
<ul>
<li><a href="#A17627">plp.inventory_in_stock() oid=17627</a></li>
</ul>
<h2>All 1 functions (by self_time)</h2>
<a name="A17627" />
<h3>Function plp.inventory_in_stock() oid=17627 (<a id="toggle_17627"
                href="javascript:toggle_div('toggle_17627', 'div_17627')">show</a>)</h3>
<p>
self_time = 7,037 &micro;s<br/>
total_time = 7,037 &micro;s
</p>
<table border="0" cellpadding="0" cellspacing="0">
  <tr>
    <td valign="top"><b><code>plp.inventory_in_stock&nbsp;</code></b></td>
    <td><b><code>(p_inventory_id integer)</code></b></td>
  </tr>
  <tr>
    <td colspan="2">
      <b><code>&nbsp;&nbsp;&nbsp;&nbsp;RETURNS&nbsp;boolean</code></b>
    </td>
  </tr>
</table>
<div id="div_17627" style="display: none">
<center>
<table class="linestats" border="1" cellpadding="0" cellspacing="0" width="80%">
  <tr>
    <th width="10%">Line</th>
    <th width="10%">exec_count</th>
    <th width="10%">total_time</th>
    <th width="10%">longest_time</th>
    <th width="60%">Source Code</th>
  </tr>
  <tr>
    <td align="right"><code>0</code></td>
    <td align="right">1</td>
    <td class="bar" align="right">7037</td>
    <td align="right">7037</td>
    <td align="left"><code><b>--&nbsp;Function&nbsp;Totals</b></code></td>
  </tr>
  <tr>
    <td align="right"><code>1</code></td>
    <td align="right">0</td>
    <td class="bar" align="right">0</td>
    <td align="right">0</td>
    <td align="left"><code></code></td>
  </tr>
  <tr>
    <td align="right"><code>2</code></td>
    <td align="right">0</td>
    <td class="bar" align="right">0</td>
    <td align="right">0</td>
    <td align="left"><code>DECLARE</code></td>
  </tr>
  <tr>
    <td align="right"><code>3</code></td>
    <td align="right">0</td>
    <td class="bar" align="right">0</td>
    <td align="right">0</td>
    <td align="left"><code>&nbsp;&nbsp;&nbsp;&nbsp;v_rentals&nbsp;INTEGER;</code></td>
  </tr>
  <tr>
    <td align="right"><code>4</code></td>
    <td align="right">0</td>
    <td class="bar" align="right">0</td>
    <td align="right">0</td>
    <td align="left"><code>&nbsp;&nbsp;&nbsp;&nbsp;v_out&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;INTEGER;</code></td>
  </tr>
  <tr>
    <td align="right"><code>5</code></td>
    <td align="right">1</td>
    <td class="bar" align="right">7036</td>
    <td align="right">7036</td>
    <td align="left"><code>BEGIN</code></td>
  </tr>
  <tr>
    <td align="right"><code>6</code></td>
    <td align="right">0</td>
    <td class="bar" align="right">0</td>
    <td align="right">0</td>
    <td align="left"><code>&nbsp;&nbsp;&nbsp;&nbsp;--&nbsp;AN&nbsp;ITEM&nbsp;IS&nbsp;IN-STOCK&nbsp;IF&nbsp;THERE&nbsp;ARE&nbsp;EITHER&nbsp;NO&nbsp;ROWS&nbsp;IN&nbsp;THE&nbsp;rental&nbsp;TABLE</code></td>
  </tr>
  <tr>
    <td align="right"><code>7</code></td>
    <td align="right">0</td>
    <td class="bar" align="right">0</td>
    <td align="right">0</td>
    <td align="left"><code>&nbsp;&nbsp;&nbsp;&nbsp;--&nbsp;FOR&nbsp;THE&nbsp;ITEM&nbsp;OR&nbsp;ALL&nbsp;ROWS&nbsp;HAVE&nbsp;return_date&nbsp;POPULATED</code></td>
  </tr>
  <tr>
    <td align="right"><code>8</code></td>
    <td align="right">1</td>
    <td class="bar" align="right">1026</td>
    <td align="right">1026</td>
    <td align="left"><code>IF&nbsp;NOT&nbsp;EXISTS&nbsp;(SELECT&nbsp;1&nbsp;FROM&nbsp;plp.rental&nbsp;WHERE&nbsp;inventory_id&nbsp;=&nbsp;&nbsp;&nbsp;&nbsp;p_inventory_id)&nbsp;THEN</code></td>
  </tr>
  <tr>
    <td align="right"><code>9</code></td>
    <td align="right">0</td>
    <td class="bar" align="right">0</td>
    <td align="right">0</td>
    <td align="left"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;RETURN&nbsp;TRUE;</code></td>
  </tr>
  <tr>
    <td align="right"><code>10</code></td>
    <td align="right">0</td>
    <td class="bar" align="right">0</td>
    <td align="right">0</td>
    <td align="left"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;END&nbsp;IF;</code></td>
  </tr>
  <tr>
    <td align="right"><code>11</code></td>
    <td align="right">0</td>
    <td class="bar" align="right">0</td>
    <td align="right">0</td>
    <td align="left"><code></code></td>
  </tr>
  <tr>
    <td align="right"><code>12</code></td>
    <td align="right">1</td>
    <td class="bar" align="right">5937</td>
    <td align="right">5937</td>
    <td align="left"><code>&nbsp;&nbsp;&nbsp;&nbsp;SELECT&nbsp;COUNT(rental_id)&nbsp;INTO&nbsp;v_out</code></td>
  </tr>
  <tr>
    <td align="right"><code>13</code></td>
    <td align="right">0</td>
    <td class="bar" align="right">0</td>
    <td align="right">0</td>
    <td align="left"><code>&nbsp;&nbsp;&nbsp;&nbsp;FROM&nbsp;plp.rental&nbsp;WHERE&nbsp;EXISTS&nbsp;(SELECT&nbsp;1&nbsp;FROM&nbsp;plp.inventory</code></td>
  </tr>
  <tr>
    <td align="right"><code>14</code></td>
    <td align="right">0</td>
    <td class="bar" align="right">0</td>
    <td align="right">0</td>
    <td align="left"><code>&nbsp;&nbsp;&nbsp;&nbsp;WHERE&nbsp;inventory.inventory_id&nbsp;=&nbsp;p_inventory_id)</code></td>
  </tr>
  <tr>
    <td align="right"><code>15</code></td>
    <td align="right">0</td>
    <td class="bar" align="right">0</td>
    <td align="right">0</td>
    <td align="left"><code>&nbsp;&nbsp;&nbsp;&nbsp;AND&nbsp;rental.return_date&nbsp;IS&nbsp;NULL;</code></td>
  </tr>
  <tr>
    <td align="right"><code>16</code></td>
    <td align="right">1</td>
    <td class="bar" align="right">71</td>
    <td align="right">71</td>
    <td align="left"><code>&nbsp;&nbsp;&nbsp;&nbsp;IF&nbsp;v_out&nbsp;&gt;&nbsp;0&nbsp;THEN</code></td>
  </tr>
  <tr>
    <td align="right"><code>17</code></td>
    <td align="right">0</td>
    <td class="bar" align="right">0</td>
    <td align="right">0</td>
    <td align="left"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;RETURN&nbsp;FALSE;</code></td>
  </tr>
  <tr>
    <td align="right"><code>18</code></td>
    <td align="right">0</td>
    <td class="bar" align="right">0</td>
    <td align="right">0</td>
    <td align="left"><code>&nbsp;&nbsp;&nbsp;&nbsp;ELSE</code></td>
  </tr>
  <tr>
    <td align="right"><code>19</code></td>
    <td align="right">1</td>
    <td class="bar" align="right">5</td>
    <td align="right">5</td>
    <td align="left"><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;RETURN&nbsp;TRUE;</code></td>
  </tr>
  <tr>
    <td align="right"><code>20</code></td>
    <td align="right">0</td>
    <td class="bar" align="right">0</td>
    <td align="right">0</td>
    <td align="left"><code>&nbsp;&nbsp;&nbsp;&nbsp;END&nbsp;IF;</code></td>
  </tr>
  <tr>
    <td align="right"><code>21</code></td>
    <td align="right">0</td>
    <td class="bar" align="right">0</td>
    <td align="right">0</td>
    <td align="left"><code>END&nbsp;</code></td>
  </tr>
</table>
</center>
</div>
</body>
</html>
